## ros-one-pinocchio 3.9.0-19noble.20260226.2057

=== CMakeLists.txt ===
#
# Copyright (c) 2015-2025 CNRS INRIA
# Copyright (c) 2015 Wandercraft, 86 rue de Paris 91400 Orsay, France.
#

cmake_minimum_required(VERSION 3.22)

set(PROJECT_NAME pinocchio)
set(PROJECT_DESCRIPTION
    "A fast and flexible implementation of Rigid Body Dynamics algorithms and their analytical derivatives"
)
set(PROJECT_URL "http://github.com/stack-of-tasks/pinocchio")
set(PROJECT_CUSTOM_HEADER_EXTENSION "hpp")
if(NOT BUILD_STANDALONE_PYTHON_INTERFACE)
  set(PROJECT_USE_CMAKE_EXPORT TRUE)
endif()
set(PROJECT_USE_KEYWORD_LINK_LIBRARIES TRUE)
set(PROJECT_COMPATIBILITY_VERSION AnyNewerVersion)
set(PINOCCHIO_PROJECT_SOURCE_DIR ${CMAKE_CURRENT_LIST_DIR})
# To enable jrl-cmakemodules compatibility with workspace we must define the two following lines
set(PROJECT_AUTO_RUN_FINALIZE FALSE)
set(PROJECT_SOURCE_DIR ${CMAKE_CURRENT_LIST_DIR})

# Disable -Werror on Unix for now.
set(CXX_DISABLE_WERROR True)
set(CMAKE_VERBOSE_MAKEFILE True)

# ----------------------------------------------------
# --- OPTIONS  ---------------------------------------
# Need to be set before including base.cmake
# ----------------------------------------------------
option(INSTALL_DOCUMENTATION "Generate and install the documentation" OFF)

# Check if the submodule cmake have been initialized
set(JRL_CMAKE_MODULES "${CMAKE_CURRENT_LIST_DIR}/cmake")
if(EXISTS "${JRL_CMAKE_MODULES}/base.cmake")
  message(STATUS "JRL cmakemodules found in 'cmake/' git submodule")
else()
  find_package(jrl-cmakemodules QUIET CONFIG)
  if(jrl-cmakemodules_FOUND)
    get_property(
      JRL_CMAKE_MODULES
      TARGET jrl-cmakemodules::jrl-cmakemodules
      PROPERTY INTERFACE_INCLUDE_DIRECTORIES)
    message(STATUS "JRL cmakemodules found on system at ${JRL_CMAKE_MODULES}")
  else()
    message(STATUS "JRL cmakemodules not found. Let's fetch it.")
    include(FetchContent)
    FetchContent_Declare("jrl-cmakemodules"
                         GIT_REPOSITORY "https://github.com/jrl-umi3218/jrl-cmakemodules.git")
    FetchContent_MakeAvailable("jrl-cmakemodules")
    FetchContent_GetProperties("jrl-cmakemodules" SOURCE_DIR JRL_CMAKE_MODULES)
  endif()
endif()

set(DOXYGEN_USE_MATHJAX YES)

# ----------------------------------------------------
# --- Policy -----------------------------------------
# CMake Policy setup
# ----------------------------------------------------
# Policy can be removed when cmake_minimum_required is updated.

# We also set CMAKE_POLICY_DEFAULT_CMPXXXX because CMake modules can reset policy and redefine some
# macros like `find_dependency` that will not use our policy.

# Use BoostConfig module distributed by boost library instead of using FindBoost module distributed
# by CMake (to remove in 3.30). This policy is not working when using clang-cl.
if(NOT WIN32 OR NOT ${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
  if(POLICY CMP0167)
    cmake_policy(SET CMP0167 NEW)
    set(CMAKE_POLICY_DEFAULT_CMP0167 NEW)
  endif()
endif()
# install() DESTINATION paths are normalized (to remove in 3.31).
if(POLICY CMP0177)
  cmake_policy(SET CMP0177 NEW)
  set(CMAKE_POLICY_DEFAULT_CMP0177 NEW)
endif()
include("${JRL_CMAKE_MODULES}/base.cmake")

compute_project_args(PROJECT_ARGS LANGUAGES CXX)
project(${PROJECT_NAME} ${PROJECT_ARGS})

include("${JRL_CMAKE_MODULES}/python.cmake")
include("${JRL_CMAKE_MODULES}/boost.cmake")
include("${JRL_CMAKE_MODULES}/ide.cmake")
include("${JRL_CMAKE_MODULES}/apple.cmake")
include(CMakeDependentOption)

# If needed, set CMake policy for APPLE systems
apply_default_apple_configuration()

# Force C++ standard to be C++11 at least
check_minimal_cxx_standard(11 ENFORCE)

# --- OPTIONS ----------------------------------------
option(BUILD_BENCHMARK "Build the benchmarks" OFF)
option(BUILD_EXAMPLES "Build the examples" ON)
option(BUILD_UTILS "Build the utils" OFF)
option(GENERATE_PYTHON_STUBS "Generate the Python stubs associated to the Python library" OFF)
option(BUILD_WITH_COMMIT_VERSION "Build libraries by setting specific commit version" OFF)

if(DEFINED BUILD_UNIT_TESTS)
  message(
    AUTHOR_WARNING
      "BUILD_UNIT_TESTS is deprecated. Use BUILD_TESTING instead.\
    If you are manually building Pinocchio from source in an existing build folder,\
    we suggest that you delete your build folder and make a new one.")
  set(BUILD_TESTING ${BUILD_UNIT_TESTS})
endif(DEFINED BUILD_UNIT_TESTS)

option(BUILD_ADVANCED_TESTING "Build the advanced tests (multiprecision, etc.) of Pinocchio" OFF)

# --- OPTIONAL DEPENDENCIES -------------------------
option(BUILD_WITH_URDF_SUPPORT "Build the library with the URDF format support" ON)
option(BUILD_WITH_SDF_SUPPORT "Build the library with the SDF format support" OFF)
option(BUILD_WITH_COLLISION_SUPPORT
       "Build the library with the collision support (required HPP-FCL)" OFF)
option(BUILD_WITH_AUTODIFF_SUPPORT
       "Build the library with the automatic differentiation support (via CppAD)" OFF)
option(BUILD_WITH_CASADI_SUPPORT "Build the library with the support of CASADI" OFF)
# cppadcodgen don't build well with CL
if(NOT WIN32)
  option(BUILD_WITH_CODEGEN_SUPPORT
         "Build the library with the support of code generation (via CppADCodeGen)" OFF)
endif()
option(BUILD_WITH_OPENMP_SUPPORT "Build the library with the OpenMP support" OFF)
option(BUILD_WITH_EXTRA_SUPPORT "Build the library with extra algorithms support" OFF)
cmake_dependent_option(
  BUILD_PYTHON_BINDINGS_WITH_BOOST_MPFR_SUPPORT
  "Build the Python interface with Boost.Multiprecision MPFR support" OFF BUILD_PYTHON_INTERFACE
  OFF)
cmake_dependent_option(BUILD_WITH_LIBPYTHON "Build the library with Python format support" ON
                       "BUILD_PYTHON_INTERFACE" OFF)
if(APPLE)
  option(BUILD_WITH_ACCELERATE_SUPPORT "Build Pinocchio with the Accelerate support" OFF)
else(APPLE)
  set(BUILD_WITH_ACCELERATE_SUPPORT FALSE)
endif(APPLE)

option(INITIALIZE_WITH_NAN "Initialize Eigen entries with NaN" OFF)
option(CHECK_RUNTIME_MALLOC "Check if some memory allocations are performed at runtime" OFF)

option(ENABLE_TEMPLATE_INSTANTIATION "Template instantiation of the main library" ON)

option(BUILD_WITH_RTSAN "Build with the Realtime Sanitizer (clang >=20, linux/mac only)" OFF)

set(PINOCCHIO_MODEL_DIR "${PROJECT_SOURCE_DIR}/models")

if(BUILD_BENCHMARK
   OR BUILD_EXAMPLES
   OR BUILD_TESTING)
  # example-robot-data is required
  if(EXAMPLE_ROBOT_DATA_MODEL_DIR)
    file(REAL_PATH "${EXAMPLE_ROBOT_DATA_MODEL_DIR}" EXAMPLE_ROBOT_DATA_MODEL_DIR EXPAND_TILDE)
    message(STATUS "Using provided example-robot-data at: ${EXAMPLE_ROBOT_DATA_MODEL_DIR}")
  elseif(EXISTS "${CMAKE_CURRENT_LIST_DIR}/models/example-robot-data/CMakeLists.txt")
    set(EXAMPLE_ROBOT_DATA_MODEL_DIR "${PINOCCHIO_MODEL_DIR}/example-robot-data/robots")
  else()
    find_package(example-robot-data REQUIRED CONFIG)
    get_target_property(EXAMPLE_ROBOT_DATA_MODEL_DIR_DEF example-robot-data::example-robot-data
                        INTERFACE_COMPILE_DEFINITIONS)
    string(REPLACE "EXAMPLE_ROBOT_DATA_MODEL_DIR=" "" EXAMPLE_ROBOT_DATA_MODEL_DIR_QUOTES
                   "${EXAMPLE_ROBOT_DATA_MODEL_DIR_DEF}")
    string(REPLACE "\"" "" EXAMPLE_ROBOT_DATA_MODEL_DIR "${EXAMPLE_ROBOT_DATA_MODEL_DIR_QUOTES}")
    message(STATUS "Using system example-robot-data at: ${EXAMPLE_ROBOT_DATA_MODEL_DIR}")
  endif()
endif()

# Variable containing all the cflags definition, options and libraries to setup pkg-config.
set(CFLAGS_OPTIONS)
set(CFLAGS_DEPENDENCIES)
set(LIBRARIES_DEPENDENCIES)

if(BUILD_WITH_COLLISION_SUPPORT)
  set(BUILD_WITH_HPP_FCL_SUPPORT TRUE)
endif()
if(BUILD_WITH_CODEGEN_SUPPORT)
  set(BUILD_WITH_CPPAD_CODEGEN_SUPPORT TRUE)
  set(BUILD_WITH_AUTODIFF_SUPPORT ON)
endif()
if(BUILD_WITH_AUTODIFF_SUPPORT)
  set(BUILD_WITH_CPPAD_SUPPORT TRUE)
endif()
if(BUILD_WITH_LIBPYTHON)
  set(BUILD_WITH_PYTHON_PARSER_SUPPORT TRUE)
endif()

if(BUILD_WITH_EXTRA_SUPPORT)
  list(APPEND CFLAGS_OPTIONS "-DPINOCCHIO_WITH_EXTRA_SUPPORT")
endif()

if(INITIALIZE_WITH_NAN)
  message(STATUS "Initialize with NaN all the Eigen entries.")
endif(INITIALIZE_WITH_NAN)

if(CHECK_RUNTIME_MALLOC)
  message(STATUS "Check if some memory allocations are performed at runtime.")
endif(CHECK_RUNTIME_MALLOC)

if(ENABLE_TEMPLATE_INSTANTIATION)
  message(STATUS "Template instantiation of the main library")
  list(APPEND CFLAGS_OPTIONS "-DPINOCCHIO_ENABLE_TEMPLATE_INSTANTIATION")
  list(APPEND LIBRARIES_DEPENDENCIES ${PROJECT_NAME}_default)
endif(ENABLE_TEMPLATE_INSTANTIATION)

macro(TAG_LIBRARY_VERSION target)
  set_target_properties(${target} PROPERTIES SOVERSION ${PROJECT_VERSION})
endmacro(TAG_LIBRARY_VERSION)

# ----------------------------------------------------
# --- DEPENDENCIES -----------------------------------
# ----------------------------------------------------
set(CMAKE_MODULE_PATH "${JRL_CMAKE_MODULES}/find-external/CppAD/" ${CMAKE_MODULE_PATH})
add_project_dependency(Eigen3 REQUIRED PKG_CONFIG_REQUIRES "eigen3 >= 3.0.5")

if(BUILD_WITH_URDF_SUPPORT)
  add_project_dependency(urdfdom_headers REQUIRED)
  add_project_dependency(urdfdom REQUIRED PKG_CONFIG_REQUIRES "urdfdom >= 0.2.0")
  set(urdfdom_VERSION ${urdfdom_headers_VERSION})
  list(APPEND CFLAGS_DEPENDENCIES "-DPINOCCHIO_WITH_URDFDOM")

  if(${urdfdom_VERSION} VERSION_GREATER "0.4.2")
    check_minimal_cxx_standard(11 ENFORCE)
    message(
      STATUS
        "Since urdfdom >= 1.0.0, the default C++ standard is C++11. The project is then compiled with C++11 standard."
    )
  endif()
endif()

if(BUILD_WITH_SDF_SUPPORT)
  include(${JRL_CMAKE_MODULES}/sdformat.cmake)
  search_for_sdformat(REQUIRED)
  if(SDFormat_FOUND)
    check_minimal_cxx_standard(11 REQUIRED)
    include_directories(${SDFormat_INCLUDE_DIRS})
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SDFormat_CXX_FLAGS}")
    list(APPEND CFLAGS_DEPENDENCIES "-DPINOCCHIO_WITH_SDFORMAT")
  endif()
endif()

set(BUILD_WITH_PARSERS_SUPPORT BUILD_WITH_URDF_SUPPORT OR BUILD_WITH_SDF_SUPPORT)

if(BUILD_WITH_PARSERS_SUPPORT)
  list(APPEND LIBRARIES_DEPENDENCIES ${PROJECT_NAME}_parsers)
endif()

if(BUILD_WITH_AUTODIFF_SUPPORT)
  # Check first CppADCodeGen
  if(BUILD_WITH_CODEGEN_SUPPORT)
    # No need to add cppadcg to pkg-config (no lib and header in the same directory than cppad)
    add_project_dependency(cppadcg 2.4.1 REQUIRED)
    list(APPEND LIBRARIES_DEPENDENCIES ${PROJECT_NAME}_cppadcg)
  endif(BUILD_WITH_CODEGEN_SUPPORT)

  add_project_dependency(
    cppad 20180000.0 REQUIRED
    PKG_CONFIG_REQUIRES "cppad >= 20220624.0"
    FIND_EXTERNAL "CppAD")
  list(APPEND LIBRARIES_DEPENDENCIES ${PROJECT_NAME}_cppad)
endif(BUILD_WITH_AUTODIFF_SUPPORT)

if(BUILD_WITH_CASADI_SUPPORT)
  add_project_dependency(casadi 3.4.5 REQUIRED PKG_CONFIG_REQUIRES "casadi >= 3.4.5")

  # Normalize CasADi link target across versions. Prefer imported target (casadi::casadi), then
  # legacy target (casadi)
  if(NOT TARGET casadi::casadi AND TARGET casadi)
    add_library(casadi::casadi ALIAS casadi)
  endif()
  list(APPEND LIBRARIES_DEPENDENCIES ${PROJECT_NAME}_casadi)
endif(BUILD_WITH_CASADI_SUPPORT)

if(BUILD_WITH_OPENMP_SUPPORT)
  add_project_dependency(OpenMP REQUIRED)
endif()

if(BUILD_WITH_EXTRA_SUPPORT)
  list(APPEND LIBRARIES_DEPENDENCIES ${PROJECT_NAME}_extra qhullcpp qhull_r)
  add_project_dependency(Qhull COMPONENTS qhullcpp qhull_r REQUIRED)
  message(STATUS "Found Qhull.")
endif()

set(BOOST_REQUIRED_COMPONENTS filesystem serialization)

set_boost_default_options()
export_boost_default_options()
add_project_dependency(Boost REQUIRED COMPONENTS ${BOOST_REQUIRED_COMPONENTS})

if(Boost_VERSION_STRING VERSION_LESS 1.81)
  if(BUILD_WITH_URDF_SUPPORT AND "${urdfdom_VERSION}" VERSION_GREATER "0.4.2")
    check_minimal_cxx_standard(11 ENFORCE)
    message(
      STATUS
        "Since urdfdom >= 1.0.0, the default C++ standard is C++11. The project is then compiled with C++11 standard."
    )
  endif()
else()
  # Boost.Math will be C++14 starting in July 2023 (Boost 1.82 release)
  check_minimal_cxx_standard(14 ENFORCE)
endif()

if(BUILD_PYTHON_INTERFACE)

=== benchmark/CMakeLists.txt ===
#
# Copyright (c) 2015-2023 CNRS INRIA
#

# ----------------------------------------------------
# --- BENCHMARK --------------------------------------
# ----------------------------------------------------
add_custom_target(bench)

add_project_private_dependency(benchmark REQUIRED)

function(ADD_PINOCCHIO_BENCH name)
  set(options
      PARSERS
      COLLISION
      PARALLEL
      COLLISION_PARALLEL
      CPPADCG
      CPPAD
      PARSERS_OPTIONAL
      COLLISION_OPTIONAL
      PARALLEL_OPTIONAL
      COLLISION_PARALLEL_OPTIONAL
      CPPADCG_OPTIONAL
      CPPAD_OPTIONAL)
  set(oneValueArgs)
  set(multiValueArgs)
  cmake_parse_arguments(bench "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})

  set(bench_name "pinocchio-${name}")
  add_executable(${bench_name} ${name}.cpp)

  target_compile_definitions(
    ${bench_name}
    PRIVATE PINOCCHIO_MODEL_DIR="${PINOCCHIO_MODEL_DIR}"
            "EXAMPLE_ROBOT_DATA_MODEL_DIR=\"${EXAMPLE_ROBOT_DATA_MODEL_DIR}\""
            COAL_DISABLE_HPP_FCL_WARNINGS)

  target_link_libraries(${bench_name} PRIVATE pinocchio_default)
  target_link_libraries(${bench_name} PRIVATE benchmark::benchmark)

  modernize_target_link_libraries(
    ${bench_name}
    SCOPE PRIVATE
    TARGETS Boost::filesystem
    LIBRARIES ${Boost_FILESYSTEM_LIBRARY}}
    INCLUDE_DIRS ${Boost_INCLUDE_DIRS})

  set(cppad_special_define OFF)

  if(bench_PARSERS OR (bench_PARSERS_OPTIONAL AND TARGET pinocchio_parsers))
    target_link_libraries(${bench_name} PRIVATE pinocchio_parsers)
  endif()
  if(bench_COLLISION OR (bench_COLLISION_OPTIONAL AND TARGET pinocchio_collision))
    target_link_libraries(${bench_name} PRIVATE pinocchio_collision)
  endif()
  if(bench_PARALLEL OR (bench_PARALLEL_OPTIONAL AND TARGET pinocchio_parallel))
    target_link_libraries(${bench_name} PRIVATE pinocchio_parallel)
  endif()
  if(bench_COLLISION_PARALLEL
     OR (bench_COLLISION_PARALLEL_OPTIONAL AND TARGET pinocchio_collision_parallel))
    target_link_libraries(${bench_name} PRIVATE pinocchio_collision_parallel)
  endif()
  if(bench_CPPADCG OR (bench_CPPADCG_OPTIONAL AND TARGET pinocchio_cppadcg))
    target_link_libraries(${bench_name} PRIVATE pinocchio_cppadcg)
    set(cppad_special_define ON)
  endif()
  if(bench_CPPAD OR (bench_CPPAD_OPTIONAL AND TARGET pinocchio_cppad))
    target_link_libraries(${bench_name} PRIVATE pinocchio_cppad)
    set(cppad_special_define ON)
  endif()

  if(cppad_special_define)
    target_compile_definitions(${bench_name}
                               PRIVATE PINOCCHIO_CXX_COMPILER=\"${CMAKE_CXX_COMPILER}\")
    target_link_libraries(${bench_name} PRIVATE ${CMAKE_DL_LIBS})
  endif()

  add_dependencies(bench ${bench_name})
endfunction()

# timings
#
add_pinocchio_bench(timings PARSERS)
if(BUILD_WITH_CODEGEN_SUPPORT)
  add_pinocchio_bench(timings-cg PARSERS CPPADCG)
endif()

if(BUILD_WITH_OPENMP_SUPPORT)
  add_pinocchio_bench(timings-parallel PARSERS PARALLEL COLLISION_PARALLEL_OPTIONAL)
endif()

# timings cholesky
#
add_pinocchio_bench(timings-cholesky PARSERS)

# timings derivatives
#
add_pinocchio_bench(timings-derivatives PARSERS)
if(BUILD_WITH_AUTODIFF_SUPPORT)
  # timings-cppad-jit
  add_pinocchio_bench(timings-cppad-jit CPPAD)
endif()

# timings-eigen
add_pinocchio_bench(timings-eigen)
modernize_target_link_libraries(
  pinocchio-timings-eigen
  SCOPE PUBLIC
  TARGETS Eigen3::Eigen
  INCLUDE_DIRS ${EIGEN3_INCLUDE_DIR})

# timings-geometry
#
if(BUILD_WITH_URDF_SUPPORT AND BUILD_WITH_COLLISION_SUPPORT)
  add_pinocchio_bench(timings-geometry PARSERS COLLISION)
endif()

# timings-jacobian
#
add_pinocchio_bench(timings-jacobian PARSERS)

# timings-contact-dynamics
#
add_pinocchio_bench(timings-delassus-operations PARSERS)
add_pinocchio_bench(timings-contact-dynamics PARSERS)
add_pinocchio_bench(timings-constrained-dynamics-derivatives PARSERS)

# timings-impulse-dynamics
#
add_pinocchio_bench(timings-impulse-dynamics PARSERS)
add_pinocchio_bench(timings-impulse-dynamics-derivatives PARSERS)

=== bindings/CMakeLists.txt ===
#
# Copyright (c) 2016-2019 CNRS INRIA
#

add_subdirectory(python)
if(BUILD_PYTHON_INTERFACE)
  set(PYWRAP
      ${PYWRAP}
      PARENT_SCOPE)
endif(BUILD_PYTHON_INTERFACE)

=== cmake/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.22)

set(PROJECT_NAME "jrl-cmakemodules")
set(PROJECT_DESCRIPTION "CMake utility toolbox")
set(PROJECT_URL "http://github.com/jrl-umi3218/${PROJECT_NAME}")

project(${PROJECT_NAME} DESCRIPTION ${PROJECT_DESCRIPTION} LANGUAGES CXX)

if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
  set(PROJECT_JRL_CMAKE_MODULE_DIR ${CMAKE_CURRENT_LIST_DIR})
  include(base.cmake)
  COMPUTE_PROJECT_ARGS(PROJECT_ARGS LANGUAGES CXX)
  project(${PROJECT_NAME} ${PROJECT_ARGS})

  # Add a dummy library with a useful INTERFACE_INCLUDE_DIRECTORIES
  add_library(${PROJECT_NAME} INTERFACE)
  set(INSTALL_DIR "${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME}")
  target_include_directories(
    ${PROJECT_NAME}
    INTERFACE $<INSTALL_INTERFACE:${INSTALL_DIR}>
  )

  # find . -maxdepth 1 -type d ! -path './.*' | sort
  install(
    DIRECTORY
      ./boost
      ./cython
      ./doxygen
      ./dynamic_graph
      ./find-external
      ./github
      ./gtest
      ./hpp
      ./image
      ./sphinx
      ./stubgen
      ./_unittests
    DESTINATION ${INSTALL_DIR}
  )

  # find . -maxdepth 1 -type f ! -path './.*' | sort
  install(
    FILES
      ./announce-gen
      ./apple.cmake
      ./base.cmake
      ./boost.cmake
      ./catkin.cmake
      ./CMakeLists.txt
      ./cmake_reinstall.cmake.in
      ./cmake_uninstall.cmake.in
      ./compiler.cmake
      ./componentConfig.cmake.in
      ./Config.cmake.in
      ./config.h.cmake
      ./config.hh.cmake
      ./coverage.cmake
      ./cpack.cmake
      ./createshexe.cmake
      ./cxx11.cmake
      ./cxx-standard.cmake
      ./debian.cmake
      ./deprecated.hh.cmake
      ./distcheck.cmake
      ./dist.cmake
      ./doxygen.cmake
      ./eigen.cmake
      ./filefilter.txt
      ./fix-license.sh
      ./geometric-tools.cmake
      ./git-archive-all.py
      ./git-archive-all.sh
      ./gitlog-to-changelog
      ./GNUInstallDirs.cmake
      ./gtest.cmake
      ./header.cmake
      ./hpp.cmake
      ./ide.cmake
      ./idl.cmake
      ./idlrtc.cmake
      ./install-data.cmake
      ./install-helpers.cmake
      ./julia.cmake
      ./kineo.cmake
      ./lapack.cmake
      ./LICENSE
      ./logging.cmake
      ./man.cmake
      ./memorycheck_unit_test.cmake.in
      ./metapodfromurdf.cmake
      ./modernize-links.cmake
      ./msvc-specific.cmake
      ./msvc.vcxproj.user.in
      ./openhrp.cmake
      ./openhrpcontroller.cmake
      ./openrtm.cmake
      ./oscheck.cmake
      ./package-config.cmake
      ./package.xml
      ./pixi.py
      ./pkg-config.cmake
      ./pkg-config.pc.cmake
      ./portability.cmake
      ./post-project.cmake
      ./pthread.cmake
      ./pyproject.py
      ./python.cmake
      ./python-helpers.cmake
      ./qhull.cmake
      ./README.md
      ./release.cmake
      ./relpath.cmake
      ./ros2.cmake
      ./ros.cmake
      ./sdformat.cmake
      ./setup.cfg
      ./shared-library.cmake
      ./sphinx.cmake
      ./stubs.cmake
      ./swig.cmake
      ./test.cmake
      ./tracy.cmake
      ./tracy.hh.cmake
      ./uninstall.cmake
      ./version.cmake
      ./version-script.cmake
      ./version-script-test.lds
      ./warning.hh.cmake
      ./xacro.cmake
    DESTINATION ${INSTALL_DIR}
  )

  install(TARGETS ${PROJECT_NAME} EXPORT ${TARGETS_EXPORT_NAME})

  SETUP_PROJECT_PACKAGE_FINALIZE()
endif()

=== examples/CMakeLists.txt ===
#
# Copyright (c) 2015-2024 CNRS INRIA
#

# Compute flags outside the macro to avoid recomputing it for each tests
cxx_flags_by_compiler_frontend(MSVC _USE_MATH_DEFINES OUTPUT EXAMPLE_PRIVATE_DEFINITIONS)

function(ADD_PINOCCHIO_CPP_EXAMPLE EXAMPLE)
  if(NOT BUILD_STANDALONE_PYTHON_INTERFACE)
    set(options PARSERS CPPAD CPPADCG CASADI)
    set(oneValueArgs)
    set(multiValueArgs)
    cmake_parse_arguments(example "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})

    get_filename_component(EXAMPLE_NAME ${EXAMPLE} NAME)
    set(EXAMPLE_NAME "${PROJECT_NAME}-example-cpp-${EXAMPLE_NAME}")
    add_unit_test(${EXAMPLE_NAME} "${EXAMPLE}.cpp")
    target_link_libraries(${EXAMPLE_NAME} PUBLIC ${PROJECT_NAME})

    if(example_PARSERS)
      target_link_libraries(${EXAMPLE_NAME} PUBLIC ${PROJECT_NAME}_parsers)
    endif()

    if(example_CPPAD)
      target_link_libraries(${EXAMPLE_NAME} PUBLIC ${PROJECT_NAME}_cppad)
    endif()

    if(example_CPPADCG)
      target_link_libraries(${EXAMPLE_NAME} PUBLIC ${PROJECT_NAME}_cppadcg)
    endif()

    if(example_CASADI)
      target_link_libraries(${EXAMPLE_NAME} PUBLIC ${PROJECT_NAME}_casadi)
    endif()

    target_compile_definitions(${EXAMPLE_NAME} PRIVATE ${EXAMPLE_PRIVATE_DEFINITIONS}
                                                       COAL_DISABLE_HPP_FCL_WARNINGS)

    modernize_target_link_libraries(
      ${EXAMPLE_NAME}
      SCOPE PRIVATE
      TARGETS Boost::filesystem
      LIBRARIES ${Boost_FILESYSTEM_LIBRARY}}
      INCLUDE_DIRS ${Boost_INCLUDE_DIRS})

    # There is no RPATH in Windows, then we must use the PATH to find the DLL
    if(WIN32)
      string(REPLACE ";" "\\\;" _PATH "$ENV{PATH}")
      set(ENV_VARIABLES
          "PATH=${_PATH}\\\;${PROJECT_BINARY_DIR}/src\\\;${PROJECT_BINARY_DIR}/bindings/python/pinocchio"
      )
      set_tests_properties(${EXAMPLE_NAME} PROPERTIES ENVIRONMENT "${ENV_VARIABLES}")
    endif()
    if(TARGET example-robot-data::example-robot-data)
      target_link_libraries(${EXAMPLE_NAME} PRIVATE example-robot-data::example-robot-data)
    else()
      target_compile_definitions(
        ${EXAMPLE_NAME} PRIVATE "EXAMPLE_ROBOT_DATA_MODEL_DIR=\"${EXAMPLE_ROBOT_DATA_MODEL_DIR}\"")
    endif()
  endif()
endfunction()

add_pinocchio_cpp_example(inverse-kinematics)
add_pinocchio_cpp_example(inverse-kinematics-3d)
add_pinocchio_cpp_example(overview-simple)
add_pinocchio_cpp_example(overview-lie)
add_pinocchio_cpp_example(overview-SE3)
add_pinocchio_cpp_example(interpolation-SE3)
add_pinocchio_cpp_example(model-graph PARSERS)
add_pinocchio_cpp_example(model-configuration-converter PARSERS)

if(BUILD_WITH_URDF_SUPPORT)
  add_pinocchio_cpp_example(overview-urdf PARSERS)
  add_pinocchio_cpp_example(build-reduced-model PARSERS)
  add_pinocchio_cpp_example(geometry-models PARSERS)
  add_pinocchio_cpp_example(kinematics-derivatives PARSERS)
  add_pinocchio_cpp_example(forward-dynamics-derivatives PARSERS)
  add_pinocchio_cpp_example(inverse-dynamics-derivatives PARSERS)
  if(BUILD_ADVANCED_TESTING)
    add_pinocchio_cpp_example(multiprecision PARSERS)
  endif()
endif()

if(BUILD_WITH_COLLISION_SUPPORT)
  if(BUILD_WITH_URDF_SUPPORT)
    add_pinocchio_cpp_example(collisions PARSERS)
  endif()
endif()

if(BUILD_PYTHON_INTERFACE)
  set(${PROJECT_NAME}_PYTHON_EXAMPLES
      inverse-kinematics
      inverse-kinematics-3d
      overview-simple
      kinematics-derivatives
      forward-dynamics-derivatives
      inverse-dynamics-derivatives
      model-graph
      model-configuration-converter
      ellipsoid-joint-kinematics)

  if(BUILD_WITH_URDF_SUPPORT)
    list(
      APPEND
      ${PROJECT_NAME}_PYTHON_EXAMPLES
      overview-urdf
      gepetto-viewer
      build-reduced-model
      robot-wrapper-viewer
      geometry-models)
  endif()

  if(BUILD_WITH_COLLISION_SUPPORT)
    list(
      APPEND
      ${PROJECT_NAME}_PYTHON_EXAMPLES
      sample-model-viewer
      display-shapes
      simulation-pendulum
      simulation-closed-kinematic-chains
      model-graph-geometry)
    if(BUILD_WITH_URDF_SUPPORT)
      list(
        APPEND
        ${PROJECT_NAME}_PYTHON_EXAMPLES
        meshcat-viewer
        meshcat-viewer-dae
        viser-viewer
        collisions
        collision-with-point-clouds
        append-urdf-model-with-another-model
        simulation-contact-dynamics
        # talos-simulation
        static-contact-dynamics)
    endif()
  endif()

  if(BUILD_WITH_OPENMP_SUPPORT)
    list(APPEND ${PROJECT_NAME}_PYTHON_EXAMPLES run-algo-in-parallel)
  endif()

  foreach(EXAMPLE ${${PROJECT_NAME}_PYTHON_EXAMPLES})
    set(EXAMPLE_NAME "${PROJECT_NAME}-example-py-${EXAMPLE}")
    add_python_unit_test("${EXAMPLE_NAME}" "examples/${EXAMPLE}.py" "bindings/python")
    get_test_property(${EXAMPLE_NAME} ENVIRONMENT _ENVIRONMENT)
    set_tests_properties(
      "${EXAMPLE_NAME}"
      PROPERTIES ENVIRONMENT
                 "${_ENVIRONMENT};EXAMPLE_ROBOT_DATA_MODEL_DIR=${EXAMPLE_ROBOT_DATA_MODEL_DIR}")
    add_windows_dll_path_to_test(${EXAMPLE_NAME})
  endforeach()
endif()

add_subdirectory(casadi)
add_subdirectory(cppad)
add_subdirectory(codegen)

=== src/CMakeLists.txt ===
#
# Copyright (c) 2015-2023 CNRS INRIA
# Copyright (c) 2015 Wandercraft, 86 rue de Paris 91400 Orsay, France.
#
# ----------------------------------------------------
# --- INCLUDE ----------------------------------------
# ----------------------------------------------------

# Create header-only target All other target will depend on it.
add_library(${PROJECT_NAME}_headers INTERFACE)
# On CMake 3.16, we can't target_sources(${PROJECT_NAME}_headers INTERFACE
# ${${PROJECT_NAME}_CORE_PUBLIC_HEADERS})

# Enforce the preprocessed version of boost::list and boost::vector This information is redundant
# with the content of include/pinocchio/container/boost-container-limits.hpp but it avoids any
# compilation issue.
target_compile_definitions(${PROJECT_NAME}_headers INTERFACE BOOST_MPL_LIMIT_LIST_SIZE=30
                                                             BOOST_MPL_LIMIT_VECTOR_SIZE=30)

if(INITIALIZE_WITH_NAN)
  target_compile_definitions(${PROJECT_NAME}_headers INTERFACE EIGEN_INITIALIZE_MATRICES_BY_NAN)
endif()

if(CHECK_RUNTIME_MALLOC)
  target_compile_definitions(${PROJECT_NAME}_headers INTERFACE PINOCCHIO_EIGEN_CHECK_MALLOC
                                                               EIGEN_RUNTIME_NO_MALLOC)
endif(CHECK_RUNTIME_MALLOC)

modernize_target_link_libraries(
  ${PROJECT_NAME}_headers
  SCOPE INTERFACE
  TARGETS Eigen3::Eigen
  INCLUDE_DIRS ${EIGEN3_INCLUDE_DIR})
modernize_target_link_libraries(
  ${PROJECT_NAME}_headers
  SCOPE INTERFACE
  TARGETS Boost::boost Boost::serialization
  LIBRARIES ${Boost_SERIALIZATION_LIBRARY}
  INCLUDE_DIRS ${Boost_INCLUDE_DIRS})

target_include_directories(
  ${PROJECT_NAME}_headers
  INTERFACE $<INSTALL_INTERFACE:include> $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
            $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>)

cxx_flags_by_compiler_frontend(
  MSVC "/bigobj"
  OUTPUT PUBLIC_OPTIONS
  FILTER)
target_compile_options(${PROJECT_NAME}_headers INTERFACE ${PUBLIC_OPTIONS})

cxx_flags_by_compiler_frontend(MSVC "NOMINMAX" OUTPUT PUBLIC_DEFINITIONS)
target_compile_definitions(${PROJECT_NAME}_headers INTERFACE ${PUBLIC_DEFINITIONS})

install(
  TARGETS ${PROJECT_NAME}_headers
  EXPORT ${TARGETS_EXPORT_NAME}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

# Define a compiled target This functions take sources and scalar type to use
function(PINOCCHIO_TARGET target_name)
  set(options INTERFACE)
  set(oneValueArgs SCALAR LIBRARY_PUBLIC_SCOPE)
  set(multiValueArgs SOURCES)
  cmake_parse_arguments(ARGS "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})

  set(LIB_NAME "${target_name}")

  # Manage different scope type if building an interface or shared library
  set(LIBRARY_TYPE SHARED)
  set(LIBRARY_PUBLIC_SCOPE PUBLIC)
  if(ARGS_INTERFACE)
    set(LIBRARY_TYPE INTERFACE)
    set(LIBRARY_PUBLIC_SCOPE INTERFACE)
  endif()

  # Export PUBLIC scope to caller
  if(ARGS_LIBRARY_PUBLIC_SCOPE)
    set(${ARGS_LIBRARY_PUBLIC_SCOPE}
        ${LIBRARY_PUBLIC_SCOPE}
        PARENT_SCOPE)
  endif()

  add_library(${LIB_NAME} ${LIBRARY_TYPE})
  add_library(${PROJECT_NAME}::${LIB_NAME} ALIAS ${LIB_NAME})
  target_link_libraries(${LIB_NAME} ${LIBRARY_PUBLIC_SCOPE} ${PROJECT_NAME}_headers)

  # On CMake 3.16 we can't call target_sources or set_target_properties with LINKER_LANGUAGE,
  # INSTALL_RPATH and VERSION on an INTERFACE target.
  if(NOT ARGS_INTERFACE OR CMAKE_VERSION GREATER 3.16)
    target_sources(${LIB_NAME} PRIVATE ${ARGS_SOURCES})
    target_sources(
      ${LIB_NAME} PRIVATE ${${PROJECT_NAME}_CORE_PUBLIC_HEADERS}) # For IDE to get includes part of
                                                                  # the project automatically.
    set_target_properties(
      ${LIB_NAME}
      PROPERTIES LINKER_LANGUAGE CXX
                 INSTALL_RPATH "\$ORIGIN"
                 VERSION ${PROJECT_VERSION}
                 CXX_VISIBILITY_PRESET hidden
                 VISIBILITY_INLINES_HIDDEN ON)
  endif()

  if(ENABLE_TEMPLATE_INSTANTIATION AND NOT ARGS_INTERFACE)
    set(PINOCCHIO_CONTEXT_FILE_VALUE "pinocchio/context/${ARGS_SCALAR}.hpp")
    target_compile_definitions(
      ${LIB_NAME}
      PUBLIC PINOCCHIO_ENABLE_TEMPLATE_INSTANTIATION
      PRIVATE PINOCCHIO_CONTEXT_FILE="${PINOCCHIO_CONTEXT_FILE_VALUE}")
  endif()

  target_include_directories(
    ${LIB_NAME} ${LIBRARY_PUBLIC_SCOPE} $<INSTALL_INTERFACE:include>
    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>)

  if(BUILD_WITH_COMMIT_VERSION)
    tag_library_version(${LIB_NAME})
  endif()

  install(
    TARGETS ${LIB_NAME}
    EXPORT ${TARGETS_EXPORT_NAME}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endfunction()

# Define a template instantiation target
function(PINOCCHIO_SPECIFIC_TYPE scalar_name scope)
  set(LIB_NAME "${PROJECT_NAME}_${scalar_name}")
  if(ENABLE_TEMPLATE_INSTANTIATION)
    pinocchio_target(
      ${LIB_NAME}
      SCALAR ${scalar_name}
      SOURCES ${${PROJECT_NAME}_CORE_SOURCES}
      LIBRARY_PUBLIC_SCOPE PUBLIC_SCOPE)
    # By default DEFINE_SYMBOL add -D${LIB_NAME}_EXPORTS. Don't use ${LIB_NAME}_EXPORTS define since
    # pinocchio/config.hpp use pinocchio_EXPORTS. This allow to use the same DLLAPI define for all
    # template instantiation libraries.
    set_target_properties(${LIB_NAME} PROPERTIES DEFINE_SYMBOL "${PROJECT_NAME}_EXPORTS")
    set(${scope}
        ${PUBLIC_SCOPE}
        PARENT_SCOPE)
  else()
    pinocchio_target(
      ${LIB_NAME}
      SCALAR ${scalar_name}
      SOURCES ${${PROJECT_NAME}_CORE_SOURCES}
      LIBRARY_PUBLIC_SCOPE PUBLIC_SCOPE
      INTERFACE)
    set(${scope}
        ${PUBLIC_SCOPE}
        PARENT_SCOPE)
  endif()
endfunction()

function(PINOCCHIO_CONFIG directory lib_name)
  string(TOUPPER ${lib_name} upper_lib_name)
  generate_configuration_header_v2(
    INCLUDE_DIR
    ${PROJECT_BINARY_DIR}/include
    HEADER_DIR
    pinocchio/${directory}
    FILENAME
    config.hpp
    LIBRARY_NAME
    ${upper_lib_name}
    EXPORT_SYMBOL
    ${lib_name}_EXPORTS)
endfunction()

add_source_group(${PROJECT_NAME}_CORE_SOURCES)
add_source_group(${PROJECT_NAME}_PARSERS_SOURCES)
add_source_group(${PROJECT_NAME}_EXTRA_SOURCES)
add_source_group(${PROJECT_NAME}_VISUALIZERS_SOURCES)
add_header_group(${PROJECT_NAME}_CORE_PUBLIC_HEADERS)
add_header_group(${PROJECT_NAME}_PARSERS_PUBLIC_HEADERS)
add_header_group(${PROJECT_NAME}_COLLISION_PUBLIC_HEADERS)
add_header_group(${PROJECT_NAME}_EXTRA_PUBLIC_HEADERS)
add_header_group(${PROJECT_NAME}_CORE_GENERATED_PUBLIC_HEADERS)
add_header_group(${PROJECT_NAME}_VISUALIZERS_PUBLIC_HEADERS)

# Define the default target (double).
#
# This target will also have hpp-fcl and workspace module in it.
pinocchio_specific_type(default DEFAULT_SCOPE)

# Some core library algorithms have different behavior if PINOCCHIO_WITH_HPP_FCL is defined. Since
# some are template instantiated, or some user can link only on pinocchio_default, we muste define
# PINOCCHIO_WITH_HPP_FCL in pinocchio_default.
if(BUILD_WITH_HPP_FCL_SUPPORT)
  target_compile_definitions(
    pinocchio_default
    PUBLIC PINOCCHIO_WITH_HPP_FCL
    PRIVATE COAL_DISABLE_HPP_FCL_WARNINGS)
  target_include_directories(
    pinocchio_default PUBLIC $<TARGET_PROPERTY:hpp-fcl::hpp-fcl,INTERFACE_INCLUDE_DIRECTORIES>)
endif()

# Define the extra target This target hold extra algorithms.
if(BUILD_WITH_EXTRA_SUPPORT)
  set(EXTRA_LIB_NAME "${PROJECT_NAME}_extra")

  pinocchio_target(
    ${EXTRA_LIB_NAME}
    SCALAR default
    SOURCES ${${PROJECT_NAME}_EXTRA_SOURCES} ${${PROJECT_NAME}_EXTRA_PUBLIC_HEADERS})
  pinocchio_config(extra ${EXTRA_LIB_NAME})

  target_link_libraries(${EXTRA_LIB_NAME} PUBLIC ${PROJECT_NAME}_default Qhull::qhullcpp
                                                 Qhull::qhull_r)

  target_compile_definitions(${EXTRA_LIB_NAME} PUBLIC PINOCCHIO_WITH_EXTRA_SUPPORT)
endif()

# Define the parallel target.
if(BUILD_WITH_OPENMP_SUPPORT)
  set(PARALLEL_LIB_NAME "${PROJECT_NAME}_parallel")

  pinocchio_target(
    ${PARALLEL_LIB_NAME}
    SCALAR default
    SOURCES ${${PROJECT_NAME}_PARALLEL_PUBLIC_HEADERS}
    INTERFACE)

  target_link_libraries(${PARALLEL_LIB_NAME} INTERFACE ${PROJECT_NAME}_default OpenMP::OpenMP_CXX)
endif()

# Define the collision target.
if(BUILD_WITH_HPP_FCL_SUPPORT)
  set(COLLISION_LIB_NAME "${PROJECT_NAME}_collision")

  pinocchio_target(
    ${COLLISION_LIB_NAME}
    SCALAR default
    SOURCES ${${PROJECT_NAME}_COLLISION_SOURCES} ${${PROJECT_NAME}_COLLISION_PUBLIC_HEADERS})
  pinocchio_config(collision ${COLLISION_LIB_NAME})

  target_compile_definitions(
    ${COLLISION_LIB_NAME}
    PUBLIC PINOCCHIO_WITH_HPP_FCL
    PRIVATE COAL_DISABLE_HPP_FCL_WARNINGS)
  target_link_libraries(${COLLISION_LIB_NAME} PUBLIC ${PROJECT_NAME}_default hpp-fcl::hpp-fcl)

  # Define the collision parallel target
  if(BUILD_WITH_OPENMP_SUPPORT)
    set(COLLISION_PARALLEL_LIB_NAME "${PROJECT_NAME}_collision_parallel")

    pinocchio_target(
      ${COLLISION_PARALLEL_LIB_NAME}
      SCALAR default
      SOURCES ${${PROJECT_NAME}_COLLISION_PARALLEL_PUBLIC_HEADERS}
      INTERFACE)

    target_link_libraries(${COLLISION_PARALLEL_LIB_NAME} INTERFACE ${COLLISION_LIB_NAME}
                                                                   OpenMP::OpenMP_CXX)
  endif()
endif()

# Define the visualizers target
set(VISUALIZERS_LIB_NAME "${PROJECT_NAME}_visualizers")
pinocchio_target(
  ${VISUALIZERS_LIB_NAME}
  SCALAR default
  SOURCES ${${PROJECT_NAME}_VISUALIZERS_SOURCES} ${${PROJECT_NAME}_VISUALIZERS_PUBLIC_HEADERS})
pinocchio_config(visualizers ${VISUALIZERS_LIB_NAME})
target_link_libraries(${VISUALIZERS_LIB_NAME} PUBLIC ${PROJECT_NAME}_default)
if(BUILD_WITH_HPP_FCL_SUPPORT)
  target_compile_definitions(
    ${VISUALIZERS_LIB_NAME}
    PUBLIC PINOCCHIO_WITH_HPP_FCL
    PRIVATE COAL_DISABLE_HPP_FCL_WARNINGS)
  target_link_libraries(${VISUALIZERS_LIB_NAME} PUBLIC hpp-fcl::hpp-fcl)
endif()

# Define the parsers target.
#
# This target will have common tools for parsing/managing files and URDF/SRDF/SDF format support.
if(BUILD_WITH_PARSERS_SUPPORT)
  set(PARSERS_LIB_NAME "${PROJECT_NAME}_parsers")

  pinocchio_target(
    ${PARSERS_LIB_NAME}
    SCALAR default
    SOURCES ${${PROJECT_NAME}_PARSERS_SOURCES} ${${PROJECT_NAME}_PARSERS_PUBLIC_HEADERS})
  pinocchio_config(parsers ${PARSERS_LIB_NAME})

  target_link_libraries(${PARSERS_LIB_NAME} PUBLIC ${PROJECT_NAME}_default)
  if(BUILD_WITH_HPP_FCL_SUPPORT)
    target_link_libraries(${PARSERS_LIB_NAME} PUBLIC ${PROJECT_NAME}_collision)
    target_compile_definitions(${PARSERS_LIB_NAME} PRIVATE COAL_DISABLE_HPP_FCL_WARNINGS)
  endif()

  modernize_target_link_libraries(
    ${PARSERS_LIB_NAME}
    SCOPE PUBLIC
    TARGETS Boost::filesystem
    LIBRARIES ${Boost_FILESYSTEM_LIBRARY}}
    INCLUDE_DIRS ${Boost_INCLUDE_DIRS})

  # Special care of urdfdom version
  if(BUILD_WITH_URDF_SUPPORT)
    target_compile_definitions(${PARSERS_LIB_NAME} PUBLIC PINOCCHIO_WITH_URDFDOM)

    if(${urdfdom_VERSION} VERSION_LESS "0.3.0")
      target_compile_definitions(${PARSERS_LIB_NAME}
                                 PRIVATE PINOCCHIO_URDFDOM_COLLISION_WITH_GROUP_NAME)
    endif()
    # defines types from version 0.4.0
    if(NOT ${urdfdom_VERSION} VERSION_LESS "0.4.0")
      target_compile_definitions(${PARSERS_LIB_NAME} PRIVATE PINOCCHIO_URDFDOM_TYPEDEF_SHARED_PTR)
    endif()
    # std::shared_ptr appears from version 1.0.0
    if(${urdfdom_VERSION} VERSION_GREATER "0.4.2")
      target_compile_definitions(${PARSERS_LIB_NAME} PRIVATE PINOCCHIO_URDFDOM_USE_STD_SHARED_PTR)
    endif()

    modernize_target_link_libraries(
      ${PARSERS_LIB_NAME}
      SCOPE PUBLIC
      TARGETS urdfdom::urdf_parser
      LIBRARIES ${urdfdom_LIBRARIES}
      INCLUDE_DIRS ${urdfdom_INCLUDE_DIRS})
  endif()

  if(BUILD_WITH_SDF_SUPPORT)

=== unittest/CMakeLists.txt ===
#
# Copyright (c) 2015-2024 CNRS INRIA
# Copyright (c) 2015 Wandercraft, 86 rue de Paris 91400 Orsay, France.
#

# --- MACROS ------------------------------------------------------------------
# --- MACROS ------------------------------------------------------------------
# --- MACROS ------------------------------------------------------------------

function(ADD_TEST_CFLAGS target)
  if(NOT BUILD_STANDALONE_PYTHON_INTERFACE)
    get_cpp_test_name(${target} ${CMAKE_CURRENT_SOURCE_DIR} test_name)
    foreach(ARG ${ARGN})
      set_property(
        TARGET ${test_name}
        APPEND_STRING
        PROPERTY COMPILE_FLAGS "${ARG} ")
    endforeach()
  endif()
endfunction()

# Compute flags outside the macro to avoid recomputing it for each tests
cxx_flags_by_compiler_frontend(MSVC _USE_MATH_DEFINES OUTPUT TEST_PRIVATE_DEFINITIONS)

function(GET_CPP_TEST_NAME name src_dir full_test_name)
  string(REPLACE "${PINOCCHIO_UNIT_TEST_DIR}" "" prefix_name "${src_dir}")
  string(REGEX REPLACE "[/]" "-" prefix_name "${prefix_name}-")

  set(${full_test_name}
      "${PROJECT_NAME}-test-cpp${prefix_name}${name}"
      PARENT_SCOPE)
endfunction()

set(PINOCCHIO_UNIT_TEST_DIR ${CMAKE_CURRENT_SOURCE_DIR})

function(ADD_PINOCCHIO_UNIT_TEST name)
  if(NOT BUILD_STANDALONE_PYTHON_INTERFACE)
    set(options
        HEADER_ONLY
        PARSERS
        EXTRA
        COLLISION
        PARALLEL
        VISUALIZERS
        PYTHON_PARSER
        PARSERS_OPTIONAL
        EXTRA_OPTIONAL
        COLLISION_OPTIONAL
        PARALLEL_OPTIONAL)
    set(oneValueArgs)
    set(multiValueArgs PACKAGES)
    cmake_parse_arguments(unit_test "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})

    set(PKGS ${unit_test_PACKAGES})

    get_cpp_test_name(${name} ${CMAKE_CURRENT_SOURCE_DIR} TEST_NAME)
    add_unit_test(${TEST_NAME} ${name}.cpp)

    set(MODULE_NAME "${NAME}Test")
    string(REPLACE "-" "_" MODULE_NAME ${MODULE_NAME})
    target_compile_definitions(
      ${TEST_NAME}
      PRIVATE ${TEST_PRIVATE_DEFINITIONS} BOOST_TEST_DYN_LINK BOOST_TEST_MODULE=${MODULE_NAME}
              PINOCCHIO_MODEL_DIR=\"${PINOCCHIO_MODEL_DIR}\" COAL_DISABLE_HPP_FCL_WARNINGS)

    # There is no RPATH in Windows, then we must use the PATH to find the DLL
    if(WIN32)
      string(REPLACE ";" "\\\;" _PATH "$ENV{PATH}")
      set(ENV_VARIABLES
          "PATH=${_PATH}\\\;${PROJECT_BINARY_DIR}/src\\\;${PROJECT_BINARY_DIR}/bindings/python/pinocchio"
      )
      set_tests_properties(${TEST_NAME} PROPERTIES ENVIRONMENT "${ENV_VARIABLES}")
    endif()

    set_target_properties(${TEST_NAME} PROPERTIES LINKER_LANGUAGE CXX)
    target_include_directories(${TEST_NAME} PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

    if(NOT unit_test_HEADER_ONLY)
      target_link_libraries(${TEST_NAME} PUBLIC ${PROJECT_NAME}_default)
    endif()

    if(unit_test_PARSERS OR (unit_test_PARSERS_OPTIONAL AND TARGET ${PROJECT_NAME}_parsers))
      target_link_libraries(${TEST_NAME} PUBLIC ${PROJECT_NAME}_parsers)
    endif()

    if(unit_test_PARALLEL OR (unit_test_PARALLEL_OPTIONAL AND TARGET ${PROJECT_NAME}_parallel))
      target_link_libraries(${TEST_NAME} PUBLIC ${PROJECT_NAME}_parallel)
    endif()

    if(unit_test_COLLISION OR (unit_test_COLLISION_OPTIONAL AND TARGET ${PROJECT_NAME}_collision))
      target_link_libraries(${TEST_NAME} PUBLIC ${PROJECT_NAME}_collision)
      if(unit_test_PARALLE OR (unit_test_PARALLEL_OPTIONAL AND TARGET ${PROJECT_NAME}_parallel))
        target_link_libraries(${TEST_NAME} PUBLIC ${PROJECT_NAME}_collision_parallel)
      endif()
    endif()

    if(unit_test_EXTRA OR (unit_test_EXTRA_OPTIONAL AND TARGET ${PROJECT_NAME}_extra))
      target_link_libraries(${TEST_NAME} PUBLIC ${PROJECT_NAME}_extra)
    endif()

    if(unit_test_VISUALIZERS)
      target_link_libraries(${TEST_NAME} PUBLIC ${PROJECT_NAME}_visualizers)
    endif()

    if(unit_test_PYTHON_PARSER)
      target_link_libraries(${TEST_NAME} PUBLIC ${PROJECT_NAME}_python_parser)
      add_windows_dll_path_to_test(${TEST_NAME})
      get_test_property(${TEST_NAME} ENVIRONMENT ENV_VARIABLES)
      compute_pythonpath(PYTHON_ENV_VARIABLES "bindings/python")
      list(APPEND ENV_VARIABLES ${PYTHON_ENV_VARIABLES})
      if(WIN32)
        # This line is mandatory because of Github action. The test run well on Windows + Conda.
        # This hide something wrong. Maybe the test is linking against the wrong Python library or
        # call the wrong interpreter.
        get_filename_component(_PYTHONHOME ${PYTHON_EXECUTABLE} PATH)
        list(APPEND ENV_VARIABLES "PYTHONHOME=${_PYTHONHOME}")
      endif()
      set_tests_properties(${TEST_NAME} PROPERTIES ENVIRONMENT "${ENV_VARIABLES}")
    endif()

    modernize_target_link_libraries(
      ${TEST_NAME}
      SCOPE PRIVATE
      TARGETS Boost::unit_test_framework
      LIBRARIES ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY})

    modernize_target_link_libraries(
      ${TEST_NAME}
      SCOPE PRIVATE
      TARGETS Boost::filesystem
      LIBRARIES ${Boost_FILESYSTEM_LIBRARY}}
      INCLUDE_DIRS ${Boost_INCLUDE_DIRS})

    if(PKGS)
      target_link_libraries(${TEST_NAME} PRIVATE ${PKGS})
    endif()
    if(TARGET example-robot-data::example-robot-data)
      target_link_libraries(${TEST_NAME} PRIVATE example-robot-data::example-robot-data)
    else()
      target_compile_definitions(
        ${TEST_NAME} PRIVATE "EXAMPLE_ROBOT_DATA_MODEL_DIR=\"${EXAMPLE_ROBOT_DATA_MODEL_DIR}\"")
    endif()
  endif()
endfunction()

macro(ADD_PINOCCHIO_PARALLEL_UNIT_TEST NAME)
  if(BUILD_WITH_OPENMP_SUPPORT)
    add_pinocchio_unit_test(${ARGV} PARALLEL)
  endif()
endmacro()

# Find Boost.UnitTestFramework
find_package(Boost COMPONENTS unit_test_framework)

# Header only
add_pinocchio_unit_test(macros HEADER_ONLY)

# Math components
add_pinocchio_unit_test(eigen-basic-op)
add_pinocchio_unit_test(eigen-tensor)
add_pinocchio_unit_test(sincos)
add_pinocchio_unit_test(quaternion)
add_pinocchio_unit_test(rpy)
add_pinocchio_unit_test(rotation)
add_pinocchio_unit_test(vector)
add_pinocchio_unit_test(eigenvalues)
add_pinocchio_unit_test(tridiagonal-matrix)
# TOOD This test contains an undefined behavior and is not stable. Reactivte the test when the fix
# is merged.

# add_pinocchio_unit_test(lanczos-decomposition)
add_pinocchio_unit_test(gram-schmidt-orthonormalisation)

# Derivatives algo
add_pinocchio_unit_test(kinematics-derivatives)
add_pinocchio_unit_test(frames-derivatives)
add_pinocchio_unit_test(rnea-derivatives)
add_pinocchio_unit_test(aba-derivatives)
add_pinocchio_unit_test(centroidal-derivatives)
add_pinocchio_unit_test(center-of-mass-derivatives)
add_pinocchio_unit_test(constrained-dynamics-derivatives)
add_pinocchio_unit_test(rnea-second-order-derivatives)

# Pinocchio features
add_pinocchio_unit_test(spatial)
add_pinocchio_unit_test(symmetric)
add_pinocchio_unit_test(aba)
add_pinocchio_parallel_unit_test(parallel-aba)
add_pinocchio_unit_test(rnea)
add_pinocchio_parallel_unit_test(parallel-rnea)
add_pinocchio_unit_test(crba)
add_pinocchio_unit_test(centroidal)
add_pinocchio_unit_test(com)
add_pinocchio_unit_test(joint-jacobian)
add_pinocchio_unit_test(cholesky)
add_pinocchio_unit_test(constrained-dynamics)
add_pinocchio_unit_test(contact-models)
add_pinocchio_unit_test(contact-dynamics)
add_pinocchio_unit_test(contact-inverse-dynamics)
add_pinocchio_unit_test(closed-loop-dynamics)
add_pinocchio_unit_test(sample-models COLLISION_OPTIONAL)
add_pinocchio_unit_test(kinematics)
# Test for unstable features TODO fix and reactivate these tests in next version
# ADD_PINOCCHIO_UNIT_TEST(delassus) ADD_PINOCCHIO_UNIT_TEST(pv-solver)
add_pinocchio_unit_test(impulse-dynamics-derivatives)
if(BUILD_WITH_SDF_SUPPORT)
  add_pinocchio_unit_test(contact-dynamics-derivatives PARSERS)
else()
  add_pinocchio_unit_test(contact-dynamics-derivatives)
endif()
add_pinocchio_unit_test(constraint-variants)
add_pinocchio_unit_test(impulse-dynamics)

add_pinocchio_unit_test(
  mjcf
  PARSERS
  COLLISION_OPTIONAL)

if(BUILD_WITH_URDF_SUPPORT)
  add_pinocchio_unit_test(
    urdf
    PARSERS
    COLLISION_OPTIONAL)

  add_pinocchio_unit_test(value PARSERS)
  if(BUILD_WITH_HPP_FCL_SUPPORT)
    add_pinocchio_unit_test(geometry-object COLLISION)
    add_pinocchio_unit_test(
      geometry-model
      PARSERS
      COLLISION)
    add_pinocchio_unit_test(
      geometry-algorithms
      PARSERS
      COLLISION)
    add_pinocchio_unit_test(
      broadphase
      PARSERS
      COLLISION)
    add_pinocchio_unit_test(
      tree-broadphase
      PARSERS
      COLLISION)
    add_pinocchio_parallel_unit_test(parallel-geometry PARSERS COLLISION)
    add_pinocchio_unit_test(
      srdf
      PARSERS
      COLLISION)
  endif()
endif()

if(BUILD_WITH_SDF_SUPPORT)
  add_pinocchio_unit_test(sdf PARSERS)
endif()

if(BUILD_WITH_EXTRA_SUPPORT)
  add_pinocchio_unit_test(
    reachable-workspace
    PARSERS
    EXTRA
    COLLISION_OPTIONAL)
endif()

add_pinocchio_unit_test(visualizer VISUALIZERS)

if(BUILD_WITH_PYTHON_PARSER_SUPPORT)
  add_pinocchio_unit_test(python_parser PYTHON_PARSER)
endif()

if(BUILD_PYTHON_INTERFACE)
  add_subdirectory(python)
endif()

# Test over the joints
add_pinocchio_unit_test(all-joints)
add_pinocchio_unit_test(joint-revolute)
add_pinocchio_unit_test(joint-prismatic)
add_pinocchio_unit_test(joint-planar)
add_pinocchio_unit_test(joint-free-flyer)
add_pinocchio_unit_test(joint-spherical)
add_pinocchio_unit_test(joint-ellipsoid)
add_pinocchio_unit_test(joint-translation)
add_pinocchio_unit_test(joint-generic)
add_pinocchio_unit_test(joint-composite)
add_pinocchio_unit_test(joint-mimic)
add_pinocchio_unit_test(joint-helical)
add_pinocchio_unit_test(joint-universal)

# Main corpus
add_pinocchio_unit_test(model COLLISION_OPTIONAL)
add_pinocchio_unit_test(data)
add_pinocchio_unit_test(joint-motion-subspace)
add_pinocchio_unit_test(compute-all-terms)
add_pinocchio_unit_test(energy)
add_pinocchio_unit_test(frames)
if(NOT MSVC AND NOT MSVC_VERSION)
  add_pinocchio_unit_test(joint-configurations)
endif()
add_pinocchio_unit_test(explog)
add_pinocchio_unit_test(finite-differences)
add_pinocchio_unit_test(visitor)
add_pinocchio_unit_test(algo-check)
add_pinocchio_unit_test(model-graph PARSERS)
add_pinocchio_unit_test(model-configuration-converter PARSERS)

# Warning ignore with pragma doesn't work for a part of this test, so we ignore two warning globally
cxx_flags_by_compiler_frontend(
  GNU -Wno-maybe-uninitialized -Wuse-after-free=0
  OUTPUT LIEGROUPS_OPTIONS
  FILTER)
add_pinocchio_unit_test(liegroups)
add_test_cflags(liegroups ${LIEGROUPS_OPTIONS})

add_pinocchio_unit_test(cartesian-product-liegroups)
add_pinocchio_unit_test(regressor)
add_pinocchio_unit_test(version)
add_pinocchio_unit_test(copy)
add_pinocchio_unit_test(contact-cholesky)
add_pinocchio_unit_test(classic-acceleration)
add_pinocchio_unit_test(coulomb-friction-cone)

# Serialization
make_directory("${CMAKE_CURRENT_BINARY_DIR}/serialization-data")
add_pinocchio_unit_test(serialization COLLISION_OPTIONAL)
add_test_cflags(
  serialization
  "-DTEST_SERIALIZATION_FOLDER=\\\"${CMAKE_CURRENT_BINARY_DIR}/serialization-data\\\"")
add_pinocchio_unit_test(csv)
add_test_cflags(
  csv "-DTEST_SERIALIZATION_FOLDER=\\\"${CMAKE_CURRENT_BINARY_DIR}/serialization-data\\\"")

add_subdirectory(algorithm)

# Multiprecision arithmetic
if(BUILD_ADVANCED_TESTING)
  add_pinocchio_unit_test(multiprecision)

  if(MPFR_FOUND)
    add_pinocchio_unit_test(multiprecision-mpfr PACKAGES mpfr gmp)
  endif()
endif()

if(BUILD_WITH_AUTODIFF_SUPPORT)
  add_subdirectory(cppad)
endif()

if(BUILD_WITH_CODEGEN_SUPPORT)
  add_subdirectory(cppadcg)
endif()

if(BUILD_WITH_CASADI_SUPPORT)
  add_subdirectory(casadi)
endif()

if(BUILD_WITH_RTSAN)
  add_pinocchio_unit_test(dynamic-allocations)
  get_cpp_test_name(dynamic-allocations ${CMAKE_CURRENT_SOURCE_DIR} test_name)
  target_compile_options(${test_name} PRIVATE -fsanitize=realtime)
  target_link_options(${test_name} PRIVATE -fsanitize=realtime)
endif()

=== utils/CMakeLists.txt ===
#
# Copyright (c) 2015-2020 CNRS INRIA
#

# --- MACROS ------------------------------------------------------------------
# --- MACROS ------------------------------------------------------------------
# --- MACROS ------------------------------------------------------------------
macro(ADD_UTIL NAME UTIL_SRC)

  if(BUILD_UTILS)
    add_executable(${NAME} "${UTIL_SRC}.cpp")
  else(BUILD_UTILS)
    add_executable(${NAME} EXCLUDE_FROM_ALL "${UTIL_SRC}.cpp")
  endif(BUILD_UTILS)

  target_link_libraries(${NAME} PUBLIC ${PROJECT_NAME})

  add_dependencies(utils ${NAME})

  if(BUILD_UTILS)
    install(TARGETS ${NAME} DESTINATION bin)
  endif(BUILD_UTILS)

endmacro(ADD_UTIL)

# --- RULES -------------------------------------------------------------------
# --- RULES -------------------------------------------------------------------
# --- RULES -------------------------------------------------------------------
add_custom_target(utils)

if(urdfdom_FOUND)
  add_util(pinocchio_read_model pinocchio_read_model)
endif(urdfdom_FOUND)

=== bindings/python/CMakeLists.txt ===
#
# Copyright (c) 2015-2023 CNRS INRIA
# Copyright (c) 2015 Wandercraft, 86 rue de Paris 91400 Orsay, France.
#

include(${JRL_CMAKE_MODULES}/python-helpers.cmake)
include(${JRL_CMAKE_MODULES}/stubs.cmake)
set(CMAKE_MODULE_PATH "${JRL_CMAKE_MODULES}/find-external/GMP"
                      "${JRL_CMAKE_MODULES}/find-external/MPFR" ${CMAKE_MODULE_PATH})

# --- PYTHON TARGET --- #
set(PYWRAP ${PROJECT_NAME}_pywrap)
set(PYWRAP
    ${PYWRAP}
    PARENT_SCOPE)

# --- COMPILE WRAPPER
make_directory("${${PROJECT_NAME}_BINARY_DIR}/bindings/python/${PROJECT_NAME}")
set(${PYWRAP}_SOURCES ${${PROJECT_NAME}_BINDINGS_PYTHON_SOURCES})
set(${PYWRAP}_HEADERS ${${PROJECT_NAME}_BINDINGS_PYTHON_PUBLIC_HEADERS})

function(PINOCCHIO_PYTHON_BINDINGS_SPECIFIC_TYPE scalar_name)
  set(scalar_name "${scalar_name}")
  set(PYTHON_LIB_NAME "${PYWRAP}_${scalar_name}")

  string(TOUPPER ${scalar_name} upper_scalar_name)
  set(EXTRA_SOURCES ${${PROJECT_NAME}_BINDINGS_PYTHON_EXTRA_${upper_scalar_name}_SOURCES})
  set(EXTRA_HEADERS ${${PROJECT_NAME}_BINDINGS_PYTHON_EXTRA_${upper_scalar_name}_PUBLIC_HEADERS})

  set(${PYTHON_LIB_NAME}_SOURCES ${${PYWRAP}_SOURCES} ${EXTRA_SOURCES})
  set(${PYTHON_LIB_NAME}_HEADERS ${${PYWRAP}_HEADERS} ${EXTRA_HEADERS})

  add_library(${PYTHON_LIB_NAME} SHARED ${${PYTHON_LIB_NAME}_SOURCES} ${${PYTHON_LIB_NAME}_HEADERS})

  # Links against accelerate
  if(BUILD_WITH_ACCELERATE_SUPPORT)
    # modernize_target_link_libraries(${PYTHON_LIB_NAME} SCOPE PUBLIC TARGETS Accelerate)
    target_link_libraries(${PYTHON_LIB_NAME} PRIVATE "-framework accelerate")
  endif(BUILD_WITH_ACCELERATE_SUPPORT)

  if(BUILD_WITH_OPENMP_SUPPORT)
    # OpenMP is linked with pinocchio_parallel target
    target_compile_definitions(${PYTHON_LIB_NAME} PRIVATE -DPINOCCHIO_PYTHON_INTERFACE_WITH_OPENMP)
  endif()
  add_dependencies(${PROJECT_NAME}-python ${PYTHON_LIB_NAME})

  # Remove lib prefix for the target and use the right define for DLLAPI definition.
  #
  # Set inlined function visibility to hidden by default. This avoid bug on OSX where two symbol
  # from two different binding (`pinocchio::python::exposeSpecificTypeFeatures`) can be wrongly
  # loaded (see https://github.com/stack-of-tasks/pinocchio/issues/2462).
  set_target_properties(
    ${PYTHON_LIB_NAME}
    PROPERTIES PREFIX ""
               DEFINE_SYMBOL "${PYWRAP}_EXPORTS"
               CXX_VISIBILITY_PRESET hidden
               VISIBILITY_INLINES_HIDDEN ON)

  # Do not report:
  #
  # * -Wconversion as the BOOST_PYTHON_FUNCTION_OVERLOADS implicitly converts.
  # * -Wcomment as latex equations have multi-line comments.
  # * -Wself-assign-overloaded as bp::self operations trigger this (Clang only).
  # * -Xclang=-fno-pch-timestamp to allow ccache to use pch
  #   (https://ccache.dev/manual/latest.html#_precompiled_headers).
  cxx_flags_by_compiler_frontend(
    GNU -Wno-conversion -Wno-comment -Wno-self-assign-overloaded -Xclang=-fno-pch-timestamp
    MSVC -Xclang=-fno-pch-timestamp
    OUTPUT PRIVATE_OPTIONS
    FILTER)
  target_compile_options(${PYTHON_LIB_NAME} PRIVATE ${PRIVATE_OPTIONS})

  set(PINOCCHIO_PYTHON_CONTEXT_FILE_VALUE "pinocchio/bindings/python/context/${scalar_name}.hpp")
  target_compile_definitions(
    ${PYTHON_LIB_NAME}
    PRIVATE PINOCCHIO_PYTHON_CONTEXT_FILE="${PINOCCHIO_PYTHON_CONTEXT_FILE_VALUE}"
            PINOCCHIO_PYTHON_MODULE_NAME=${PYTHON_LIB_NAME})

  set_target_properties(${PYTHON_LIB_NAME} PROPERTIES VERSION ${PROJECT_VERSION})
  if(BUILD_WITH_COMMIT_VERSION)
    tag_library_version(${PYTHON_LIB_NAME})
  endif(BUILD_WITH_COMMIT_VERSION)
  add_header_group(${PYTHON_LIB_NAME}_HEADERS)
  add_source_group(${PYTHON_LIB_NAME}_SOURCES)

  modernize_target_link_libraries(
    ${PYTHON_LIB_NAME}
    SCOPE PUBLIC
    TARGETS eigenpy::eigenpy)
  target_link_libraries(${PYTHON_LIB_NAME} PUBLIC ${PROJECT_NAME}::${PROJECT_NAME})

  if(BUILD_WITH_URDF_SUPPORT)
    # Link directly against console_bridge since we bind some enums and call
    # console_bridge::setLogLevel function.
    modernize_target_link_libraries(
      ${PYTHON_LIB_NAME}
      SCOPE PUBLIC
      TARGETS console_bridge::console_bridge
      LIBRARIES ${console_bridge_LIBRARIES}
      INCLUDE_DIRS ${console_bridge_INCLUDE_DIRS})
  endif()
  if(BUILD_WITH_HPP_FCL_SUPPORT)
    target_compile_definitions(
      ${PYTHON_LIB_NAME} PRIVATE PINOCCHIO_PYTHON_INTERFACE_WITH_HPP_FCL_PYTHON_BINDINGS
                                 COAL_DISABLE_HPP_FCL_WARNINGS)
  endif()
  if(WIN32)
    target_link_libraries(${PYTHON_LIB_NAME} PUBLIC ${PYTHON_LIBRARY})
  endif()

  set(${PYWRAP}_INSTALL_DIR ${ABSOLUTE_PYTHON_SITELIB}/${PROJECT_NAME})

  set_target_properties(
    ${PYTHON_LIB_NAME}
    PROPERTIES PREFIX ""
               SUFFIX ${PYTHON_EXT_SUFFIX}
               OUTPUT_NAME "${PYTHON_LIB_NAME}"
               LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/bindings/python/${PROJECT_NAME}"
               # On Windows, shared library are treat as binary
               RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/bindings/python/${PROJECT_NAME}")

  if(UNIX)
    get_relative_rpath(${${PYWRAP}_INSTALL_DIR} ${PYWRAP}_INSTALL_RPATH)
    set_target_properties(${PYTHON_LIB_NAME} PROPERTIES INSTALL_RPATH "${${PYWRAP}_INSTALL_RPATH}")
  endif()

  install(
    TARGETS ${PYTHON_LIB_NAME}
    EXPORT ${TARGETS_EXPORT_NAME}
    DESTINATION ${PINOCCHIO_PYTHON_INSTALL_DIR})
endfunction()

function(INSTALL_PYTHON_FILES)
  set(options)
  set(oneValueArgs MODULE)
  set(multiValueArgs FILES)
  cmake_parse_arguments(ARGS "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})

  set(SOURCE_PATH ${PROJECT_NAME})
  set(INSTALL_PATH ${PINOCCHIO_PYTHON_INSTALL_DIR})
  if(ARGS_MODULE)
    set(SOURCE_PATH ${SOURCE_PATH}/${ARGS_MODULE})
    set(INSTALL_PATH ${INSTALL_PATH}/${ARGS_MODULE})
  endif()

  foreach(f ${ARGS_FILES})
    python_build(${SOURCE_PATH} ${f})
    install(FILES ${SOURCE_PATH}/${f} DESTINATION ${INSTALL_PATH})
  endforeach()
endfunction()

if(BUILD_PYTHON_INTERFACE)
  add_custom_target(${PROJECT_NAME}-python)
  set_target_properties(${PROJECT_NAME}-python PROPERTIES EXCLUDE_FROM_DEFAULT_BUILD True)

  python_build_get_target(python_build_target)
  add_dependencies(${PROJECT_NAME}-python ${python_build_target})

  set(PKG_CONFIG_PYWRAP_REQUIRES "eigenpy >= 2.6.5")
  if(IS_ABSOLUTE ${PYTHON_SITELIB})
    set(ABSOLUTE_PYTHON_SITELIB ${PYTHON_SITELIB})
  else()
    set(ABSOLUTE_PYTHON_SITELIB ${CMAKE_INSTALL_PREFIX}/${PYTHON_SITELIB})
  endif()
  set(PINOCCHIO_PYTHON_INSTALL_DIR ${ABSOLUTE_PYTHON_SITELIB}/${PROJECT_NAME})

  pinocchio_python_bindings_specific_type(default)
  # Precompiled headers are used to speed up compilation of the Python bindings. We have also tested
  # precompiling headers for the main library's `pinocchio_default` target, but the time gain there
  # was negligible compared to the time gained in the Python bindings. We also precompile headers
  # for other scalar types as well.
  target_precompile_headers(${PYWRAP}_default PRIVATE
                            ${PROJECT_SOURCE_DIR}/include/pinocchio/bindings/python/pch.hpp)
  set(PYTHON_LIB_NAME "${PYWRAP}_default")
  set(STUBGEN_DEPENDENCIES "${PYWRAP}_default")

  if(BUILD_WITH_AUTODIFF_SUPPORT)
    pinocchio_python_bindings_specific_type(cppad cppad)
    # CPPAD_DEBUG_AND_RELEASE allow to mix debug and release versions of CppAD in the same program.
    # This can happen when Pinocchio is build in Debug mode and pycppad is build in Release mode.
    # See
    # https://coin-or.github.io/CppAD/doc/preprocessor.htm#Documented%20Here.CPPAD_DEBUG_AND_RELEASE.
    target_compile_definitions(
      ${PYWRAP}_cppad PRIVATE PYCPPAD_EXCLUDE_EIGEN_NUMTRAITS_SPECIALIZATION
                              CPPAD_DEBUG_AND_RELEASE)
    target_include_directories(${PYWRAP}_cppad SYSTEM
                               PUBLIC $<BUILD_INTERFACE:${cppad_INCLUDE_DIR}>)
    target_link_libraries(${PYWRAP}_cppad PUBLIC ${cppad_LIBRARY})
    list(APPEND STUBGEN_DEPENDENCIES "${PYWRAP}_cppad")

    target_precompile_headers(
      ${PYWRAP}_cppad PRIVATE ${PROJECT_SOURCE_DIR}/include/pinocchio/bindings/python/pch.hpp
      <cppad/cppad.hpp> <boost/mpl/int.hpp>)

    # --- INSTALL SCRIPTS
    install_python_files(MODULE cppad FILES __init__.py)
  endif(BUILD_WITH_AUTODIFF_SUPPORT)

  if(BUILD_WITH_CODEGEN_SUPPORT)
    pinocchio_python_bindings_specific_type(cppadcg cppadcg)

    # On osx, use default visiblitiy because of an issue with thread_local storage defined in
    # cppad/cg/cg.hpp header (see
    # https://github.com/stack-of-tasks/pinocchio/pull/2469#issuecomment-2461845127)
    if(APPLE)
      set_target_properties(${PYWRAP}_cppadcg PROPERTIES CXX_VISIBILITY_PRESET default)
    endif()

    # CPPAD_DEBUG_AND_RELEASE allow to mix debug and release versions of CppAD in the same program.
    target_compile_definitions(
      ${PYWRAP}_cppadcg PRIVATE PYCPPAD_EXCLUDE_EIGEN_NUMTRAITS_SPECIALIZATION
                                CPPAD_DEBUG_AND_RELEASE)
    target_include_directories(${PYWRAP}_cppadcg SYSTEM
                               PUBLIC $<BUILD_INTERFACE:${cppadcg_INCLUDE_DIR}>)
    target_link_libraries(${PYWRAP}_cppadcg PUBLIC ${cppadcg_LIBRARY} ${cppad_LIBRARY})
    list(APPEND STUBGEN_DEPENDENCIES "${PYWRAP}_cppadcg")

    target_precompile_headers(
      ${PYWRAP}_cppadcg PRIVATE ${PROJECT_SOURCE_DIR}/include/pinocchio/bindings/python/pch.hpp
      <cmath> <boost/mpl/int.hpp> <cppad/cg/support/cppadcg_eigen.hpp>)

    # --- INSTALL SCRIPTS
    install_python_files(MODULE cppadcg FILES __init__.py)
  endif(BUILD_WITH_CODEGEN_SUPPORT)

  if(BUILD_WITH_CASADI_SUPPORT)
    pinocchio_python_bindings_specific_type(casadi)
    target_link_libraries(${PYWRAP}_casadi PUBLIC casadi::casadi)
    list(APPEND STUBGEN_DEPENDENCIES "${PYWRAP}_casadi")

    target_precompile_headers(
      ${PYWRAP}_casadi PRIVATE ${PROJECT_SOURCE_DIR}/include/pinocchio/bindings/python/pch.hpp
      <casadi/casadi.hpp> <casadi/core/casadi_types.hpp> <casadi/core/code_generator.hpp>)

    # --- INSTALL SCRIPTS
    install_python_files(MODULE casadi FILES __init__.py)
  endif(BUILD_WITH_CASADI_SUPPORT)

  if(BUILD_PYTHON_BINDINGS_WITH_BOOST_MPFR_SUPPORT)
    find_package(GMP REQUIRED 6.0.0)
    find_package(MPFR REQUIRED 4.0.0)
    pinocchio_python_bindings_specific_type(mpfr)

    target_link_libraries(${PYWRAP}_mpfr PRIVATE gmp mpfr)
    list(APPEND STUBGEN_DEPENDENCIES "${PYWRAP}_mpfr")

    target_precompile_headers(
      ${PYWRAP}_mpfr PRIVATE ${PROJECT_SOURCE_DIR}/include/pinocchio/bindings/python/pch.hpp
      <boost/multiprecision/mpfr.hpp>)

    # --- INSTALL SCRIPTS
    install_python_files(MODULE mpfr FILES __init__.py)
  endif(BUILD_PYTHON_BINDINGS_WITH_BOOST_MPFR_SUPPORT)

  # --- INSTALL SCRIPTS
  install_python_files(
    FILES __init__.py
          deprecated.py
          deprecation.py
          utils.py
          robot_wrapper.py
          romeo_wrapper.py
          explog.py
          shortcuts.py
          windows_dll_manager.py)

  # --- INSTALL DERIVATIVE SCRIPTS
  install_python_files(MODULE derivative FILES xm.py dcrba.py lambdas.py)

  # --- INSTALL VISUALIZATION SCRIPTS
  install_python_files(
    MODULE visualize
    FILES __init__.py
          base_visualizer.py
          gepetto_visualizer.py
          meshcat_visualizer.py
          panda3d_visualizer.py
          rviz_visualizer.py
          viser_visualizer.py
          visualizers.py)

  # --- STUBS --- #
  if(GENERATE_PYTHON_STUBS)
    python_build_get_target(python_build_target_name)
    load_stubgen()
    # Set PYWRAP and PROJECT_NAME as stubs dependencies.
    #
    # PROJECT_NAME is mandatory (even if it's a PYWRAP dependency) to find PROJECT_NAME name DLL on
    # windows.
    generate_stubs(
      ${CMAKE_CURRENT_BINARY_DIR}
      ${PROJECT_NAME}
      ${ABSOLUTE_PYTHON_SITELIB}
      ${PYWRAP}_default
      ${PROJECT_NAME}::${PROJECT_NAME}_default
      ${STUBGEN_DEPENDENCIES}
      ${python_build_target_name})

=== examples/casadi/CMakeLists.txt ===
#
# Copyright (c) 2025 INRIA
#

function(ADD_PINOCCHIO_CPP_CASADI_EXAMPLE EXAMPLE)
  add_pinocchio_cpp_example(${EXAMPLE} CASADI)
endfunction()

if(BUILD_WITH_CASADI_SUPPORT)

  if(NOT BUILD_STANDALONE_PYTHON_INTERFACE)
    add_pinocchio_cpp_casadi_example(casadi-aba)
    add_pinocchio_cpp_casadi_example(casadi-crba)
    add_pinocchio_cpp_casadi_example(casadi-rnea)
  endif()

  if(BUILD_PYTHON_INTERFACE)
    set(${PROJECT_NAME}_CASADI_PYTHON_EXAMPLES quadrotor-ocp)
    if(BUILD_WITH_COLLISION_SUPPORT)
      list(APPEND ${PROJECT_NAME}_CASADI_PYTHON_EXAMPLES cartpole)
    endif()

    foreach(EXAMPLE ${${PROJECT_NAME}_CASADI_PYTHON_EXAMPLES})
      set(EXAMPLE_NAME "${PROJECT_NAME}-example-py-casadi-${EXAMPLE}")
      add_python_unit_test(${EXAMPLE_NAME} "examples/casadi/${EXAMPLE}.py" "bindings/python")
      get_test_property(${EXAMPLE_NAME} ENVIRONMENT _ENVIRONMENT)
      set_tests_properties(
        "${EXAMPLE_NAME}"
        PROPERTIES ENVIRONMENT
                   "${_ENVIRONMENT};EXAMPLE_ROBOT_DATA_MODEL_DIR=${EXAMPLE_ROBOT_DATA_MODEL_DIR}")
      add_windows_dll_path_to_test(${EXAMPLE_NAME})
    endforeach()
  endif()
endif()

=== examples/codegen/CMakeLists.txt ===
#
# Copyright (c) 2020-2023 INRIA
#

if(cppadcg_FOUND
   AND BUILD_WITH_CODEGEN_SUPPORT
   AND BUILD_WITH_URDF_SUPPORT)
  function(ADD_PINOCCHIO_CPP_CODEGEN_EXAMPLE EXAMPLE)
    add_pinocchio_cpp_example(
      ${EXAMPLE}
      CPPADCG
      PARSERS)
    target_link_libraries(${PROJECT_NAME}-example-cpp-${EXAMPLE} PUBLIC ${CMAKE_DL_LIBS})
    target_compile_definitions(${PROJECT_NAME}-example-cpp-${EXAMPLE}
                               PUBLIC PINOCCHIO_CXX_COMPILER=\"${CMAKE_CXX_COMPILER}\")
  endfunction()

  if(NOT BUILD_STANDALONE_PYTHON_INTERFACE)
    add_pinocchio_cpp_codegen_example(codegen-crba)
    add_pinocchio_cpp_codegen_example(codegen-rnea)
  endif()

  if(BUILD_PYTHON_INTERFACE)
    set(${PROJECT_NAME}_CODEGEN_PYTHON_EXAMPLES codegen-rnea)

    foreach(EXAMPLE ${${PROJECT_NAME}_CODEGEN_PYTHON_EXAMPLES})
      set(EXAMPLE_NAME "${PROJECT_NAME}-example-py-${EXAMPLE}")
      add_python_unit_test(${EXAMPLE_NAME} "examples/codegen/${EXAMPLE}.py" "bindings/python")
      add_windows_dll_path_to_test(${EXAMPLE_NAME})
    endforeach()
  endif()

endif()

=== examples/cppad/CMakeLists.txt ===
#
# Copyright (c) 2022 INRIA
#

if(BUILD_WITH_AUTODIFF_SUPPORT AND NOT BUILD_STANDALONE_PYTHON_INTERFACE)
  function(ADD_PINOCCHIO_CPP_AUTODIFF_EXAMPLE EXAMPLE)
    include_directories(SYSTEM ${cppadcg_INCLUDE_DIR})
    add_pinocchio_cpp_example(${EXAMPLE})
    target_link_libraries(${PROJECT_NAME}-example-cpp-${EXAMPLE} PUBLIC ${CMAKE_DL_LIBS}
                                                                        ${cppad_LIBRARY})
  endfunction()

  add_pinocchio_cpp_autodiff_example(autodiff-rnea)

  if(BUILD_PYTHON_INTERFACE)
    set(${PROJECT_NAME}_AUTODIFF_PYTHON_EXAMPLES autodiff-rnea)

    foreach(EXAMPLE ${${PROJECT_NAME}_AUTODIFF_PYTHON_EXAMPLES})
      set(EXAMPLE_NAME "${PROJECT_NAME}-example-py-${EXAMPLE}")
      add_python_unit_test(${EXAMPLE_NAME} "examples/cppad/${EXAMPLE}.py" "bindings/python")
      add_windows_dll_path_to_test(${EXAMPLE_NAME})
    endforeach()
  endif()

endif()

=== debian/changelog ===
ros-one-pinocchio (3.9.0-19noble.20260226.2057) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Justin Carpentier <justin.carpentier@inria.fr>  Thu, 26 Feb 2026 20:57:17 +0000

=== debian/control ===
Source: ros-one-pinocchio
Section: misc
Priority: optional
Maintainer: Justin Carpentier <justin.carpentier@inria.fr>
Build-Depends: debhelper (>= 9.0.0), clang, cmake, doxygen, git, libboost-all-dev, libeigen3-dev, liburdfdom-dev, python3-dev, python3-numpy, ros-one-eigenpy, ros-one-hpp-fcl, ros-one-jrl-cmakemodules, ros-one-ros-environment
Homepage: https://github.com/stack-of-tasks/pinocchio
Standards-Version: 3.9.2

Package: ros-one-pinocchio
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libeigen3-dev, liburdfdom-dev, python3-dev, python3-numpy, ros-one-eigenpy, ros-one-hpp-fcl, ros-one-ros-environment
Description: A fast and flexible implementation of Rigid Body Dynamics algorithms and their analytical derivatives.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/one/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

# Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_configure -- \
		-DFETCHCONTENT_FULLY_DISCONNECTED=OFF \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/one" \
		-DCMAKE_PREFIX_PATH="/opt/ros/one" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-one-pinocchio//opt/ros/one/lib/:$(CURDIR)/debian/ros-one-pinocchio//opt/ros/one/lib/${DEB_HOST_MULTIARCH}

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_install
